/*
 *	piecese/piecese.h - P/ECEΉVFgDLL
 *
 *	{vO쐬ɂẮAuł̗bӂƂ͂v(http://www.runan.net/) 
 *	[vO~OTips]->[C++ SDK Tips]->[VFgV[Y]QlɂĒ܂B
 *	҂̃iɁAӂ܂B
 *
 *	* Thu Jan 31 19:10:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#pragma once

/****************************************************************************
 *	PieceSystem Ver1.18 
 ****************************************************************************/

typedef struct _pffsFileHEADER {
	unsigned char mark;		// +0   }[N
	unsigned char type;		// +1   t@CE^Cv
	unsigned short ofs_data;	// +2   f[^ւ̃ItZbg
	unsigned short ofs_name;	// +4   LvVւ̃ItZbg
	unsigned short ofs_icon;	// +6   ACRւ̃ItZbg
	unsigned long resv2;		// +8   \
	unsigned long top_adrs;		// +12  擪̃AhX
	unsigned long length;		// +16  
	unsigned long crc32;		// +20  CRC32
} pffsFileHEADER;

/****************************************************************************
 *	CPieceSEClassFactory
 ****************************************************************************/

class CPieceSEClassFactory : public IClassFactory {
public:
	CPieceSEClassFactory();
	~CPieceSEClassFactory();
	/* IUnknown */
	STDMETHODIMP		QueryInterface(REFIID, LPVOID*);
	STDMETHODIMP_(ULONG)	AddRef();
	STDMETHODIMP_(ULONG)	Release();
	/* IClassFactory */
	STDMETHODIMP		CreateInstance(LPUNKNOWN, REFIID, LPVOID*);
	STDMETHODIMP		LockServer(BOOL);
protected:
	ULONG m_ref;	/* QƃJEg */
};

/****************************************************************************
 *	CPieceSE
 ****************************************************************************/

class CPieceSE : public IPersistFile, public IExtractIcon {
public:
	CPieceSE();
	~CPieceSE();
	/* IUnknown */
	STDMETHODIMP		QueryInterface(REFIID, LPVOID*);
	STDMETHODIMP_(ULONG)	AddRef();
	STDMETHODIMP_(ULONG)	Release();
	/* IPersist */
	STDMETHODIMP		GetClassID(LPCLSID);
	/* IPersistFile */
	STDMETHODIMP		IsDirty();
	STDMETHODIMP		Load(LPCOLESTR, DWORD);
	STDMETHODIMP		Save(LPCOLESTR, BOOL);
	STDMETHODIMP		SaveCompleted(LPCOLESTR);
	STDMETHODIMP		GetCurFile(LPOLESTR FAR*);
	/* IExtractIcon */
	STDMETHODIMP		GetIconLocation(UINT, LPSTR, UINT, int*, UINT*);
	STDMETHODIMP		Extract(LPCSTR, UINT, HICON*, HICON*, UINT);
protected:
	ULONG m_ref;			/* QƃJEg */
	char m_filename[MAX_PATH];	/* Ώۃt@C */
};
